using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace SampleApplication
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(664, 360);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(696, 397);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			this.gridDataBoundGrid1.Model.CellModels.Add("MyRichText", new MyGridRichTextBoxCellModel(this.gridDataBoundGrid1.Model));

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = null;
			this.gridDataBoundGrid1.DataSource = dt;

			//Get the rows numbers
			this.gridDataBoundGrid1.Model.Options.NumberedRowHeaders = true;
			this.gridDataBoundGrid1.BaseStylesMap["Row Header"].StyleInfo.CellType = "Header";

			this.gridDataBoundGrid1.Binder.InternalColumns[1].StyleInfo.CellType = "MyRichText";
			this.gridDataBoundGrid1.Binder.InternalColumns[2].StyleInfo.CellType = "FormulaCell";

			//subscribe to the event
			//this.gridDataBoundGrid1.Model.PasteCellText += new GridPasteCellTextEventHandler(grid_PasteCellText);
			this.gridDataBoundGrid1.Model.ClipboardPaste += new GridCutPasteEventHandler(grid_ClipBoardPaste);

		}

//		//the handler
//		private void grid_PasteCellText(object sender, GridPasteCellTextEventArgs e)
//		{
//			if(e.RowIndex >= this.gridDataBoundGrid1.Model.RowCount)
//			{
//				e.Cancel = true;
//			}
//		}

		private void grid_ClipBoardPaste(object sender, GridCutPasteEventArgs e)
		{
			DataObject data = (DataObject) Clipboard.GetDataObject();
			if(data.GetDataPresent(DataFormats.Text))
			{
				//get the size of teh data object in rows
				string s = (string)data.GetData(DataFormats.Text);
				string[] rows = s.Split(new char[]{'\n'});
				int numRows = rows.GetLength(0);
				if(numRows > 0 && rows[numRows - 1].Length == 0)
					numRows--; //remove extra empty row if present
//				int numCols = 0;
//				if(numRows > 0)
//				{
//					string[] cols = rows[0].Split(new char[]{'\t'});
//					numCols = cols.GetLength(0);
//				}
				
				//add rows if needed...
				if(this.gridDataBoundGrid1.Binder.IsAddNew && numRows <= 1)
					return;

				GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
				this.gridDataBoundGrid1.BeginUpdate();
				this.gridDataBoundGrid1.Binder.SuspendBinding();
				int row = cc.RowIndex;
				int oldRowCount = this.gridDataBoundGrid1.Model.RowCount;
				int extraRowIfStartAtAddNewRow = this.gridDataBoundGrid1.Binder.IsAddNew ? 1 : 0;
				while(row + numRows + extraRowIfStartAtAddNewRow > oldRowCount)
				{
					DataRow dr = dt.NewRow();
					dt.Rows.Add(dr);
					row--;
				}
				this.gridDataBoundGrid1.Binder.ResumeBinding();
				this.gridDataBoundGrid1.EndUpdate();
			}
		}
	}
}
